#include "StdAfx.h"
#include "Capusb_Main.h"

void CCapUSB_Main::DTVRecieveCallback(BYTE *pRecvData,DWORD dwRecvSize,unsigned __int64 ui64TotalRecvSize,LPVOID lpContext)
{
	static DWORD dwBeforeDraw=0;
	static DWORD dwBeforeXferCalc=0;
	static unsigned __int64 ui64BeforeTotalRecv=0;

	CCapUSB_Main *pThis=(CCapUSB_Main*)lpContext;
	if(dwRecvSize>0)
	{
		DWORD dwPutSize=pThis->m_pStreamBuf->Put(pRecvData,dwRecvSize);
		if(dwPutSize!=dwRecvSize)
		{
			// Mobt@s
			pThis->m_stStreamInfo.dwRecieveBufferOverflow++;
			DEBUG_BREAK();
			pThis->m_pStreamBuf->Clear();
		}
	}
	// ]xvZ	
	DWORD dwTime=GetTickCount();
	if(dwTime-dwBeforeXferCalc>CALCTIME_XFER_SPEED)
	{
		if(ui64TotalRecvSize>ui64BeforeTotalRecv)
		{
			pThis->m_stStreamInfo.dSpeed=(double)ui64TotalRecvSize-ui64BeforeTotalRecv;
			pThis->m_stStreamInfo.dSpeed=pThis->m_stStreamInfo.dSpeed*( 1000.0/(dwTime-dwBeforeXferCalc) );
		} else {
			pThis->m_stStreamInfo.dSpeed=0;
		}

		dwBeforeXferCalc=dwTime;
		ui64BeforeTotalRecv=ui64TotalRecvSize;
	}
	// CXbhWM_USERoRŕ\
	if(dwTime-dwBeforeDraw>REDRAWTIME_XFER_RESULT)
	{
		PostMessage(pThis->m_hWnd,WM_USER,1,NULL);
		dwBeforeDraw=dwTime;
	}
}

// Xg[
DWORD CCapUSB_Main::StreamProcThreadProc(struct StreamProcThreadParam *pStreamProc)
{
#ifdef ENABLE_ARIB_B25_PROC
	m_pTsStream=new CTsStream(pStreamProc->bB25Proc?pStreamProc->lpB25Decorder:NULL);
#else
	m_pTsStream=new CTsStream(NULL);
#endif

	try
	{
		m_wTsStreamOutput_Schedule = TS_OUTPUT_DEFAULT + 1;
		m_pTsStream->AddOutput(m_wTsStreamOutput_Schedule);

		if(m_pScheduleRec)
		{
			m_pScheduleRec->SetFilterCallback(OnScheduleSetFilter,this);
		}
		if(m_pFilterWnd)
		{
			m_pFilterWnd->SetScheduleByTimeCallback(OnFilterWndSetSchduleByTime,this);
		}

		m_pTsStream->SetDecodePSI(m_stOpt.bDecodePSI);
		m_pTsStream->SetEpgProc(m_stOpt.bProcEPG);
		m_pTsStream->SetCallbackFunc(TsCallback,this);
		while(WaitForSingleObject(m_stStreamProc.hExitEvent,0)!=WAIT_OBJECT_0)
		{
			BYTE buf[ASYNC_XFER_SIZE];
			DWORD len;
			while(m_pStreamBuf->GetDataSize()>=ASYNC_XFER_SIZE)
			{
				len=m_pStreamBuf->Get(buf,ASYNC_XFER_SIZE);
				if(len>0)
				{
					m_pTsStream->OnTsStream(buf,len,&m_stStreamInfo);
				}
			}
			// Xbhҋ@
			Sleep(1);
		}
	}
	catch(int err_code)
	{
		CATCH_INT_ERROR_CODE(err_code);
	}
	m_pTsStream->OnTsStreamTerminate(&m_stStreamInfo);
	delete m_pTsStream;
	m_wTsStreamOutput_Schedule=0;
	m_pTsStream=NULL;
#ifdef ENABLE_ARIB_B25_PROC
	if(pStreamProc->lpB25Decorder)
	{
		pStreamProc->lpB25Decorder->Release();
	}
	FreeLibrary(pStreamProc->hB25DecordLib);
#endif
	delete pStreamProc;
	ExitThread(1);
	return 0;
}

// TSXg[̃R[obN
void CCapUSB_Main::TsCallback(UINT uType,WORD wStreamID,LPVOID pData,DWORD dwVal,LPVOID lpContext)
{
	CCapUSB_Main *pThis=(CCapUSB_Main*)lpContext;
		
	switch(uType)
	{
	case TSENG_CALLBACK_PACKET:
		{
			WORD wNo=wStreamID;
			if(wNo==TS_OUTPUT_DEFAULT)
			{
				if(pThis->m_pFileRecord)
				{
					pThis->m_pFileRecord->Write(pData,dwVal);
				}
				if(pThis->m_pNetworkSend)
				{
					pThis->m_pNetworkSend->Send(pData,dwVal);
				}
			}
			if(wNo==pThis->m_wTsStreamOutput_Schedule)
			{
				if(pThis->m_pScheduleRec)
				{
					pThis->m_pScheduleRec->PutStream((BYTE*)pData,dwVal);
				}
			}
		}
		break;
	case TSENG_CALLBACK_TIME_RECIEVE:
	case TSENG_CALLBACK_STREAM_RESET:
	case TSENG_CALLBACK_PAT_RECIEVE:
	case TSENG_CALLBACK_PMT_RECIEVE:
	case TSENG_CALLBACK_NIT_RECIEVE:
	case TSENG_CALLBACK_SATELLITE_INFO:
	case TSENG_CALLBACK_SDT_RECIEVE:
		// UIɊ֘ÂÃt@Cւ̋Lq͌TSf[^Xg[̂
		pThis->TsCallbackUI(uType,wStreamID,pData,dwVal,lpContext);
		break;
	}
}