// FIFO Buffer
//  CBuffer   : ʏ
//  CBufferMT : }`Xbh̔񓯊ANZXCriticalSectionŕی
//  CBuffer_CriticalSection : gpp

#pragma once

#include <list>

// ftHg̃obt@TCY(1,048,576 byte)
#define CBUFFER_DEFAULT_FIFO_SIZE	(1<<20)

// fobOp
#define USE_CRITICAL_SECTION

struct FIFOBUFFER_DATA
{
	BYTE *pData;
	DWORD dwDataSize;
	DWORD dwReadPos;
};

// Critical Section Lapper
class CBuffer_CriticalSection
{
public:
	CBuffer_CriticalSection(CRITICAL_SECTION *lpCriticalSectionObject=NULL)
	{
		m_pCriticalSection=lpCriticalSectionObject;
#ifdef USE_CRITICAL_SECTION
		if(m_pCriticalSection) EnterCriticalSection(m_pCriticalSection);
#endif
	}
	~CBuffer_CriticalSection()
	{
#ifdef USE_CRITICAL_SECTION
		if(m_pCriticalSection) LeaveCriticalSection(m_pCriticalSection);
#endif
	}

private:
	CRITICAL_SECTION *m_pCriticalSection;
};


// Buffer
class CBuffer
{
public:
	CBuffer(DWORD dwBufferSize=CBUFFER_DEFAULT_FIFO_SIZE);
	virtual ~CBuffer(void);

	BOOL Alloc(DWORD dwBufferSize);
	void Clear(void);

	DWORD GetBufferSize();
	DWORD GetBufferEmptySize();
	DWORD GetDataSize();

	DWORD Put(BYTE *pData,DWORD dwDataSize,BOOL bAppendFront=FALSE);
	DWORD Get(BYTE *pBuffer,DWORD dwBufferSize,BOOL bPositionForward=TRUE);
	DWORD GetFrontBuffer(BYTE *pBuffer,DWORD dwBufferSize,BOOL bPositionForward=TRUE);
	BYTE ReferenceTopByte();
	DWORD crc32(DWORD dwSize);

protected:
	DWORD				m_dwBufferSize;
	std::list<FIFOBUFFER_DATA> m_listData;
	DWORD				m_dwDataSize;
};

// Multi Thread Version(with Critical Section)
class CBufferMT : public CBuffer
{
public:
	CBufferMT(DWORD dwBufferSize=CBUFFER_DEFAULT_FIFO_SIZE);
	virtual ~CBufferMT(void);

	BOOL Alloc(DWORD dwBufferSize);
	void Clear(void);

	DWORD Put(BYTE *pData,DWORD dwDataSize,BOOL bAppendFront=FALSE);
	DWORD Get(BYTE *pBuffer,DWORD dwBufferSize,BOOL bPositionForward=TRUE);
	DWORD GetFrontBuffer(BYTE *pBuffer,DWORD dwBufferSize,BOOL bPositionForward=TRUE);
	BYTE ReferenceTopByte();
	DWORD crc32(DWORD dwSize);

protected:
	CRITICAL_SECTION	m_stCriticalSection;
};