#include "../stdafx.h"
#include "TsEpgMgr.h"
#include <vector>

CTsEPGMgr::CTsEPGMgr(void)
{
	InitializeCriticalSection(&m_stEpgCriticalSection);
}

CTsEPGMgr::~CTsEPGMgr(void)
{
	Clear();
	DeleteCriticalSection(&m_stEpgCriticalSection);
}

// Sf[^폜
void CTsEPGMgr::Clear()
{
	CTsEPGMgr_CriticalSection cEpgCriticalSec(&m_stEpgCriticalSection);
	TSEpg_ServiceMap::iterator itMap;
	for(itMap=m_EpgDB.begin();itMap!=m_EpgDB.end();itMap++)
	{
		TSEpg_Map *pEpg=itMap->second;
		TSEpg_Map::iterator itData;
		size_t i=pEpg->size();
		for(itData=pEpg->begin();itData!=pEpg->end();itData++)
		{
			// Imۃf[^J
		}
		// ŏIJ
		pEpg->clear();
		delete pEpg;
	}
	m_EpgDB.clear();
}

// wT[rX̃f[^폜
void CTsEPGMgr::ClearEpg(WORD wServiceID)
{
	CTsEPGMgr_CriticalSection cEpgCriticalSec(&m_stEpgCriticalSection);
	TSEpg_ServiceMap::iterator itMap=m_EpgDB.find(wServiceID);
	if(itMap!=m_EpgDB.end())
	{
		TSEpg_Map *pEpg=itMap->second;
		TSEpg_Map::iterator itData;
		size_t i=pEpg->size();
		for(itData=pEpg->begin();itData!=pEpg->end();itData++)
		{
			// Imۃf[^J
		}
		// ŏIJ
		pEpg->clear();
		delete pEpg;
		// Xg菜
		m_EpgDB.erase(wServiceID);
	}
}

// EPGf[^x[Xɓo^ĂT[rX̐擾B
int CTsEPGMgr::GetEpgServiceCount()
{
	CTsEPGMgr_CriticalSection cEpgCriticalSec(&m_stEpgCriticalSection);
	return static_cast<int>(m_EpgDB.size());
}

// EPGf[^x[Xɓo^ĂT[rXID̃Xg(WORDz)擾B
// 擾|C^͎gp FreeEpgServiceList() ɂĊJ(̈Ⴂz邽)
WORD* CTsEPGMgr::GetEpgServiceList()
{
	CTsEPGMgr_CriticalSection cEpgCriticalSec(&m_stEpgCriticalSection);
	WORD *pRet=(WORD*)malloc(sizeof(WORD)*m_EpgDB.size());
	if(pRet)
	{
		TSEpg_ServiceMap::iterator it;
		int iCount=0;
		for(it=m_EpgDB.begin();it!=m_EpgDB.end();it++)
		{
			pRet[iCount++]=it->first;
		}
	}
	return pRet;
}

// GetEpgServiceList()Ŏ擾f[^̊J
void CTsEPGMgr::FreeEpgServiceList(WORD *pList)
{
	if(pList) free(pList);
}

// EPG}bvɓo^ꂢf[^̐擾B
int CTsEPGMgr::GetEpgDataCount(TSEpg_Map *pEpg)
{
	CTsEPGMgr_CriticalSection cEpgCriticalSec(&m_stEpgCriticalSection);
	if(pEpg)
	{
		return static_cast<int>(pEpg->size());
	}
	return 0;
}

// EPGf[^x[Xɓo^ĂT[rXID̃Xg(struct TSEPG_PROGRAM z)擾B
// 擾|C^͎gp FreeEpgDataList() ɂĊJ(̈Ⴂz邽)
struct TSEPG_PROGRAM* CTsEPGMgr::GetEpgDataList(TSEpg_Map *pEpg)
{
	CTsEPGMgr_CriticalSection cEpgCriticalSec(&m_stEpgCriticalSection);
	if(pEpg)
	{
		struct TSEPG_PROGRAM *pRet=(struct TSEPG_PROGRAM*)malloc(sizeof(struct TSEPG_PROGRAM)*pEpg->size());
		if(pRet)
		{
			TSEpg_Map::iterator it;
			int iCount=0;
			for(it=pEpg->begin();it!=pEpg->end();it++)
			{
				memcpy(&pRet[iCount++],&it->second,sizeof(struct TSEPG_PROGRAM));
			}
		}
		return pRet;
	}
	return NULL;
}

// GetEpgDataList()Ŏ擾f[^̊J
void CTsEPGMgr::FreeEpgDataList(TSEpg_Map *pEpg,struct TSEPG_PROGRAM *pList)
{
	if(pList) free(pList);
}

// w肵T[rXIDEPG}bvւ̃|C^擾B
// bFlg=TRUE A݂Ȃf[^̏ꍇÃf[^쐬
// ݂ȂꍇNULL
TSEpg_Map* CTsEPGMgr::GetEpgMap(WORD wServiceID,BOOL bNewFlg)
{
	TSEpg_ServiceMap::iterator it = m_EpgDB.find(wServiceID);
	if(it!=m_EpgDB.end())
	{
		return it->second;
	}
	else if(bNewFlg)
	{
		TSEpg_Map *pNew = new TSEpg_Map;
		if(!pNew) return NULL;
		m_EpgDB.insert(TSEpg_ServiceMapPair(wServiceID,pNew));
		it = m_EpgDB.find(wServiceID);
		if(it!=m_EpgDB.end())
		{
			// ɒǉ
			return it->second;
		}
	}
	return NULL;
}

// w肵CxgIDEPGf[^ւ̃|C^擾B
// ݂ȂꍇNULL
struct TSEPG_PROGRAM* CTsEPGMgr::GetEpgData(TSEpg_Map *pEpg,WORD wEventID)
{
	if(pEpg)
	{
		TSEpg_Map::iterator it = pEpg->find(wEventID);
		if(it!=pEpg->end())
		{
			return &it->second;
		}
	}
	return NULL;
}

// w肵T[rXID̃f[^ǉA܂͍XV
BOOL CTsEPGMgr::SetEpgData(WORD wServiceID,struct TSEPG_PROGRAM *pstNewData)
{
	CTsEPGMgr_CriticalSection cEpgCriticalSec(&m_stEpgCriticalSection);
	TSEpg_Map *pEpg = GetEpgMap(wServiceID,TRUE);
	if(!pEpg) return FALSE;

	struct TSEPG_PROGRAM *pData=GetEpgData(pEpg,pstNewData->wEventID);
	if(pData)
	{
		// XV(͖Atɂׂ)
//		if(pData->byType > pstNewData->byType)
		{
			*pData = *pstNewData;
		}
	} else {
		// VKǉ
		pEpg->insert(TSEpg_MapPair(pstNewData->wEventID,*pstNewData));
	}
	return TRUE;
}

// wA̔ԑgCxgBȂꍇNULL
// bDeleteMode=TRUE̎AwȑÕf[^͍폜
struct TSEPG_PROGRAM* CTsEPGMgr::FindEpgDataByTime(WORD wServiceID,WORD wDateMJD,DWORD dwTime,BOOL bDeleteMode)
{
	CTsEPGMgr_CriticalSection cEpgCriticalSec(&m_stEpgCriticalSection);
	TSEpg_Map *pEpg = GetEpgMap(wServiceID);
	if(!pEpg) return NULL;

	TSEpg_Map::iterator itProg;
	std::vector<WORD> EpgDeleteEventIDList;
	BOOL bFindFlg=FALSE;
	struct TSEPG_PROGRAM* pFindProg=NULL;

	for(itProg=pEpg->begin();itProg!=pEpg->end();itProg++)
	{
		struct TSEPG_PROGRAM &stProg=itProg->second;
		// Jn`IȊO͖
		if(stProg.wStartMJD>wDateMJD && stProg.wEndMJD<wDateMJD) continue;		
		// 00:00-00:00(24ԕ)
		if(!bFindFlg && stProg.wStartMJD+1==stProg.wEndMJD && stProg.dwStartTime==0x00 && stProg.dwEndTime==0x00)
		{
			// JnɑĂꍇ擾
			if( stProg.wStartMJD==wDateMJD ) bFindFlg=TRUE;
		}
		// JnƏI
		if(!bFindFlg && stProg.wStartMJD==stProg.wEndMJD )
		{
			// JnĂ邩
			if(stProg.dwStartTime<=dwTime)
			{
				// I
				if(!bFindFlg && stProg.dwEndTime==0xffffffff) bFindFlg=TRUE;
				// Jn`Iԓ
				if(!bFindFlg && stProg.wStartMJD==stProg.wEndMJD && stProg.dwEndTime>=dwTime) bFindFlg=TRUE;
			}
		}
		// Jn(JnȊOŊJnԂ߂Ă)
		if(!bFindFlg && stProg.wStartMJD+1==stProg.wEndMJD )
		{
			// ͊Jn
			if(stProg.wStartMJD==wDateMJD)
			{
				// I
				if(!bFindFlg && stProg.dwEndTime==0xffffffff) bFindFlg=TRUE;
				// Jn`Iԓ(Jnԁ`tύX)
				if(!bFindFlg && stProg.dwStartTime<=dwTime) bFindFlg=TRUE;
			}
			// ͏I
			if(stProg.wEndMJD==wDateMJD)
			{
				// I
				if(!bFindFlg && stProg.dwEndTime==0xffffffff) bFindFlg=TRUE;
				// Jn`Iԓ(tύX`I)
				if(!bFindFlg && stProg.dwEndTime>dwTime) bFindFlg=TRUE;
			}
		}
		if(bFindFlg && !pFindProg)
		{
			pFindProg = (struct TSEPG_PROGRAM*)malloc(sizeof(struct TSEPG_PROGRAM));
			if(pFindProg)
			{
				*pFindProg = stProg;
			}
		}
		// DeleteȂݒŃf[^ĂΌI
		if(!bDeleteMode && pFindProg) break;

		if(bDeleteMode)
		{
			BOOL bDeleteFlg=FALSE;
			// I
			if(!bDeleteFlg && stProg.wEndMJD < wDateMJD) bDeleteFlg=TRUE;
			// 24ԕ̏ꍇ͏Î̂̂ݍ폜Ȃ̂ŁǍ̔菜O
			if(!bDeleteFlg && !(stProg.wStartMJD+1==stProg.wEndMJD&&stProg.dwStartTime==0&&stProg.dwEndTime==0))
			{
				// IԂo
				if(!bDeleteFlg && stProg.wEndMJD == wDateMJD && stProg.dwEndTime < dwTime) bDeleteFlg=TRUE;
				// 폜̂o^
				if(bDeleteFlg)
				{
					EpgDeleteEventIDList.push_back(itProg->first);
				}
			}
		}
	}
	// 폜tÔ̂菜
	for(unsigned int i=0;i<EpgDeleteEventIDList.size();i++)
	{
		pEpg->erase(EpgDeleteEventIDList[i]);
#ifdef TSEITPARSER_DEBUG_PRINT
		char buf[80];
		wsprintf(buf,"DEL %d %04X Data=%d\n",wServiceID,EpgDeleteEventIDList[i],pEpg->size());
		OutputDebugStr(buf);
#endif
	}
	return pFindProg;
}

// 擾EPGf[^̊J
void CTsEPGMgr::FreeEpgDataMemory(struct TSEPG_PROGRAM *pData,int iCount )
{
	for(int i=0;i<iCount;i++)
	{
	}
	free(pData);
}