#pragma once
#include <map>

#ifdef _DEBUG
	#define TSEITPARSER_DEBUG_PRINT
#endif

struct TSEPG_PROGRAM
{
	BYTE	byType;			// f[^^Cv(l̂قADx)
							// 1=p/f ActualɂĎM 2=p/f otherbɂĎM 3=schedule ActualɂĎM 4=Schedule other ɂĎM
	BYTE	byVersion;		// f[^̃o[W

	WORD	wServiceID;		// T[rXID
	WORD	wEventID;		// CxgID
	char	szTitle[81];	// ^Cg
	char	szText[161];	// 

	WORD	wStartMJD;		// JnCEX	
	DWORD	dwStartTime;	// Jn(EITőBCD`ł͂ȂA0:00:000ƂbA0:00:00=86400)
	DWORD	dwDuration;		// ԑg(Srbg=1̏ꍇAI)
	WORD	wEndMJD;		// ICEX
	DWORD	dwEndTime;		// Jn(EITőBCD`ł͂ȂA0:00:000ƂbA0:00:00=86400)	
};

typedef std::map<WORD,struct TSEPG_PROGRAM>		TSEpg_Map;				// Key=CxgID , Val=ԑgƂ̏
typedef std::pair<WORD,struct TSEPG_PROGRAM>	TSEpg_MapPair;
typedef std::map<WORD,TSEpg_Map*>				TSEpg_ServiceMap;		// Key=T[rXID , Val=T[rXƂ̔ԑg\
typedef std::pair<WORD,TSEpg_Map*>				TSEpg_ServiceMapPair;


class CTsEPGMgr_CriticalSection
{
public:
	CTsEPGMgr_CriticalSection(CRITICAL_SECTION *lpCriticalSectionObject=NULL)
	{
		m_pCriticalSection=lpCriticalSectionObject;
		if(m_pCriticalSection) EnterCriticalSection(m_pCriticalSection);
	}
	~CTsEPGMgr_CriticalSection()
	{
		if(m_pCriticalSection) LeaveCriticalSection(m_pCriticalSection);
	}

private:
	CRITICAL_SECTION *m_pCriticalSection;
};


//////////////////////////////////////////////////////////////////////
// EPGf[^ǗNX
class CTsEPGMgr
{
public:
	CTsEPGMgr(void);
	~CTsEPGMgr(void);

	void Clear();
	void ClearEpg(WORD wServiceID);

	int GetEpgServiceCount();
	WORD* GetEpgServiceList();
	void FreeEpgServiceList(WORD *pList);

	int GetEpgDataCount(TSEpg_Map *pEpg);
	struct TSEPG_PROGRAM* GetEpgDataList(TSEpg_Map *pEpg);
	void FreeEpgDataList(TSEpg_Map *pEpg,struct TSEPG_PROGRAM *pList);

	BOOL SetEpgData(WORD wServiceID,struct TSEPG_PROGRAM *pstNewData);
	struct TSEPG_PROGRAM* FindEpgDataByTime(WORD wServiceID,WORD wDateMJD,DWORD dwTime,BOOL bDeleteMode=FALSE);
	void FreeEpgDataMemory(struct TSEPG_PROGRAM *pData,int iCount);

	static int TsEitParser(struct TSEPG_PROGRAM **ppstProg,int *piCount,BYTE byTableID,BYTE byVersion,WORD wServiceID,BYTE *pData);
	static void FreeTsEitParserMemory(struct TSEPG_PROGRAM *pstProg,int iCount);
#ifdef TSEITPARSER_DEBUG_PRINT
	static void TsEitParser_DebugPrintProgram(BOOL bActual,struct TS_section_header &stSecHeader,struct TSEPG_PROGRAM &stProg);
#else 
	static inline void TsEitParser_DebugPrintProgram(BOOL bActual,struct TS_section_header &stSecHeader,struct TSEPG_PROGRAM &stProg) { /*Ȃ*/}
#endif

protected:
	CRITICAL_SECTION	m_stEpgCriticalSection;
	TSEpg_ServiceMap	m_EpgDB;

	TSEpg_Map* GetEpgMap(WORD wServiceID,BOOL bNewFlg=FALSE);
	struct TSEPG_PROGRAM* GetEpgData(TSEpg_Map *pEpg,WORD wEventID);
};
